C******** intervalles de generations

      program intgen
      implicit none

      include "blk.incl"

      integer prc(nt), mrc(nt), ndes(nt)
      integer*2 ann(nt), sex(nt)
      logical pop(nt)
      real*8  eff(2,2,ande:anfi),ing(2,2,ande:anfi)
      real*8  efx(2,2,ande:anfi),inx(2,2,ande:anfi)
      real*8  efi(2,2,ande:anfi),ini(2,2,ande:anfi)
      integer i,j,k,l,n, nl,is,ip,im,i1,i2,aninc,ndia
      real*8  x,y,r,z
      logical t,ecr,chy
      character*128 str,sts,jour

c
      call fdate(jour)
      PRINT 990,jour
      print 2000
      print 1001
      read(5,*) str
      print 1002,str

c      sts='no'
c      print *,'Nom du fichier sortie (intervalles des males individuels) / no si aucun'
c      read(5,*,end=12) sts
c   12 print *,'Fichier sortie (intervalles des males individuels):',sts

       aninc=1950
       ndia=30

c read file 1
      open (1,file=str,form='FORMATTED')
      nl=0
      chy=.false.

   10 read (1,*,end=20) i,ip,im,l,n
      NL=NL+1
      if (l.lt.21) then
             l=l+2000
             chy=.true.
      else if (l.lt.100) then
             l=l+1900
             chy=.true.
             end if

      if (i.ne.nl)  then
         print 102,nl,i
         stop
         end if
      if (i.gt.nt.or.ip.gt.nt.or.im.gt.nt) then
         print 101
         stop
         end if

      prc(nl)=ip
      if (ip.lt.0) prc(nl)=0
      mrc(nl)=im
      if (im.lt.0) mrc(nl)=0
      ann(nl)=l
      sex(nl)=n

      pop(nl)=.true.
      if (prc(nl).eq.0.and.mrc(nl).eq.0) pop(nl)=.false.
      if (l.lt.ande.or.l.gt.anfi) pop(nl)=.false.

      ndes(nl)=0
      GOTO 10

   20 if (chy) print 103
      print 900, nl
      close(1)
      
c compute number of progeny
      k=0
      do i=1, nl
        if (prc(i).ne.0) ndes(prc(i))=ndes(prc(i)) + 1
        if (mrc(i).ne.0) ndes(mrc(i))=ndes(mrc(i)) + 1
        end do
      do i=1, nl
        if (ndes(i).gt.0.and.pop(i)) k=k + 1
        end do

c calcul ig
      do i=ande, anfi
        do is=1, 2
          do ip=1, 2
            eff(ip,is,i)=0.
            ing(ip,is,i)=0.
            efx(ip,is,i)=0.
            inx(ip,is,i)=0.
            efi(ip,is,i)=0.
            ini(ip,is,i)=0.
            end do
          end do
        end do

      ecr=.false.
c      if (sts.ne.'no') ecr=.true.
c      if (ecr) open (3,file=sts,form='formatted')
      do i=1, nl
        if (pop(i)) then
          is=sex(i)
          i1=-1
          i2=-1
          if (prc(i).gt.0.and.ann(prc(i)).ne.aninc) then
            x=dfloat(ann(i)-ann(prc(i)))
            if (x.gt.0.) then
              eff(1,is,ann(i))=eff(1,is,ann(i)) + 1.
              ing(1,is,ann(i))=ing(1,is,ann(i)) + x
              if (ndes(i).gt.0) then
                 efx(1,is,ann(i))=efx(1,is,ann(i)) + 1.
                 inx(1,is,ann(i))=inx(1,is,ann(i)) + x
                 end if
              if (ndes(i).ge.ndia) then
                 efi(1,is,ann(i))=efi(1,is,ann(i)) + 1.
                 ini(1,is,ann(i))=ini(1,is,ann(i)) + x
                 end if
              if (is.eq.1) i1=ann(prc(i))
              end if
            end if
          if (mrc(i).gt.0.and.ann(mrc(i)).ne.aninc) then
            x=dfloat(ann(i)-ann(mrc(i)))
            if (x.gt.0.) then
              eff(2,is,ann(i))=eff(2,is,ann(i)) + 1.
              ing(2,is,ann(i))=ing(2,is,ann(i)) + x
              if (ndes(i).gt.0) then
                 efx(2,is,ann(i))=efx(2,is,ann(i)) + 1.
                 inx(2,is,ann(i))=inx(2,is,ann(i)) + x
                 end if
              if (ndes(i).ge.ndia) then
                 efi(2,is,ann(i))=efi(2,is,ann(i)) + 1.
                 ini(2,is,ann(i))=ini(2,is,ann(i)) + x
                 end if
              if (is.eq.1) i2=ann(mrc(i))
              end if
            end if
c          if (ecr.and.is.eq.1) write (3,111) i,ndes(i),ann(i),i1,i2
c  111 format (i10,i6,3i5)
          end if
        end do
c      close (3)

      print 2100
      print 2105
      do i=ande, anfi
        r=0
        do is=1, 2
          do ip=1, 2
            x=eff(ip,is,i)
            r=r+x
            if (x.gt.0.) ing(ip,is,i)=ing(ip,is,i)/x
            end do
          end do
        if (r.gt.0.) print 112,i, ((ing(ip,is,i),ip=1,2),is=1,2),
     *         ((eff(ip,is,i),ip=1,2),is=1,2)
  112 format (i4,5x,4f8.2,5x,4f8.0)
        end do

      print 2110
      print 2105
      do i=ande, anfi
        r=0
        do is=1, 2
          do ip=1, 2
            x=efx(ip,is,i)
            r=r+x
            if (x.gt.0.) inx(ip,is,i)=inx(ip,is,i)/x
            end do
          end do
        if (r.gt.0.) print 112,i, ((inx(ip,is,i),ip=1,2),is=1,2),
     *         ((efx(ip,is,i),ip=1,2),is=1,2)
        end do

      print 2120
      print 2105
      do i=ande, anfi
        r=0
        do is=1, 2
          do ip=1, 2
            x=efi(ip,is,i)
            r=r+x
            if (x.gt.0.) ini(ip,is,i)=ini(ip,is,i)/x
            end do
          end do
        if (r.gt.0.) print 112,i, ((ini(ip,is,i),ip=1,2),is=1,2),
     *         ((efi(ip,is,i),ip=1,2),is=1,2)
        end do

      include "format.incl"

      stop
      END
