C******** proportion de genealogies connues
      program ngen

      include "blk.incl"

      integer prc(nt), mrc(nt)
      real*8  tab(ng,nt)
      real*8  moy(ng)
      integer*4   nanc(nt)
      integer*2 ann(nt), sex(nt), ngene(nt)
      integer*2 anmin,anmax
      integer i,j,k,l,n, nl, nbl,nbit,ip,im,ii,iopt,eff(0:ng)
      logical test,t,chy
      character*128 str,sor
c      real*4 gtimer, t1, t2

      include "format.incl"

       call fdate(str)
      PRINT 990,str

      print 1001
      read(5,*) str
      print 1002,str
      print 1003
      read(5,*) sor
      print 1004,sor

      open (1,file=str,form='FORMATTED')
      nl=0
      chy=.false.
c     iopt : 0=tous, 1=au moins 1 parent connu, 2=2 parents connus
      iopt=2

   10 READ (1,*,END=20) i,ip,im,l,n
      NL=NL+1
      if (l.lt.11) then
             l=l+2000
             chy=.true.
      else if (l.lt.100) then
             l=l+1900
             chy=.true.
             end if
      if (nl.eq.1) then
        anmin=l
        anmax=l
      else
        if (anmin.gt.l) anmin=l
        if (anmax.lt.l) anmax=l
        end if
      if (i.ne.nl) then
         print 102,nl,i
         stop
         end if
      if (i.gt.nt.or.ip.gt.nt.or.im.gt.nt) then
         print 101
         stop
         end if

      prc(nl)=ip
      if (ip.lt.0) prc(nl)=0
      mrc(nl)=im
      if (im.lt.0) mrc(nl)=0
      ann(nl)=l
      sex(nl)=n
      GOTO 10

   20 if (chy) print 103
      print 900,nl   
      print 4000,anmin,anmax
      if (iopt.eq.1) print 4002
      if (iopt.eq.2) print 4003

      do i=1, nl
        nanc(i)=0
        do j=1, ng
         tab(j,i)=0.
         end do
      end do
      do j=0, ng
         eff(j)=0
         end do
c  verification de pedigree
      k=0
      do i=1, nl
        ngene(i)=-1
        if (prc(i).eq.0 .and. mrc(i).eq.0)  then
            ngene(i)=0
            k=k+1
        end if
      end do
      nbit=0
      test=.true.
c      t1 = gtimer()
      do while(test .and. nbit.le.50)
        nbit=nbit+1
        j=0
        test=.false.
        do i=1, nl
          if (ngene(i).lt.0) then
            ip=prc(i)
            im=mrc(i)
            t=.true.
            if (ip.ne.0 .and. ngene(ip).lt.0) t=.false.
            if (im.ne.0 .and. ngene(im).lt.0) t=.false.
            if (t) then
              if (ip.eq.0) then
                ii=0
              else
                ii=ngene(ip)
              end if
              if (im.ne.0) ii=max(ii, ngene(im))
              ngene(i) = ii+1
              j=j+1
              if (ip.gt.0) then
                 nanc(i)=nanc(i)+nanc(ip)+1
                 call add(i,ip,tab,nt,ng)
                 end if
              if (im.gt.0) then
                 nanc(i)=nanc(i)+nanc(im)+1
                 call add(i,im,tab,nt,ng)
                 end if
            else
              test=.true.
            end if
          end if
        end do
        k=k+j
c        print 1000,nbit,k,j,nl-k
      end do

      j=0
      if (k.ne.nl) then
        do i=1,nl
          if (ngene(i).lt.0) then
            j=j+1
            if (j.lt.100) print '(3i10)',i,prc(i),mrc(i)
            end if
        end do
       end if
      if (j.gt.0) print 1104, j
c      t2=gtimer()
c      print *, 'Temps cpu : ', t2-t1

      do i=1, nl
        ii=ngene(i)
        eff(ii)=eff(ii)+1
        end do

c      print *,'Nbre maxi de generations connues par individu'
c      do i=0, ng
c        if (eff(i).gt.0) print 1000,i,eff(i)
c        end do

c edition de la connaissance individuelle des genealogies
       if (sor.ne.'no') then
         open (9,file=sor,form='formatted')
         do i=1, nl
       if (prc(i).gt.0.or.mrc(i).gt.0)  write (9,8) i,(tab(j,i),j=1,8)
            end do
         close(9)
         end if
    8 format (i5,8f10.7)

c edition des resultats par sexe, annai, selon option
      do n=2, 1, -1
        do i=anmin,anmax
          call statt(i,n,iopt,nl,tab,moy,nt,ng,ann,sex,prc,mrc,nanc)
          end do
	end do
	
      call fdate(str)
      print 991, str

      stop
      END

      subroutine add(i,ip,tab,nt,ng)
      integer i,ip,nt,ng,j,k,ng1
      real*8  tab(ng,nt)
      ng1=ng-1
      tab(1,i)=tab(1,i) + .5
      if (tab(ng,ip).gt.0.) stop 'accroitre le parametre ng'
      do j=1, ng1
        if (tab(j,ip).eq.0.) return
        k=j+1
        tab(k,i) = tab(k,i) + tab(j,ip)*.5
        end do

      return
      end

      subroutine statt
     *   (ian,isex,iopt,nl,tab,moy,nt,ng, ann,sex,prc,mrc,nanc)
      integer i,ip,nt,ng,j,k, ian, isex, iopt, n,nl
      real*8  tab(ng,nt)
      integer*4 prc(nt),mrc(nt),nanc(nt)
      real*8  moy(ng),xng,xna
      integer*2 ann(nt),sex(nt)
      logical t
      n=0
      xng=0
      xna=0.
      do i=1, ng
        moy(i)=0.d0
        end do
      do i=1, nl
        t=.true.
        if (ann(i).ne.ian .or. sex(i).ne.isex)  t=.false.
        if (iopt.eq.2 .and. (prc(i).eq.0 .or. mrc(i).eq.0))
     *        t=.false.
        if (iopt.eq.1 .and. prc(i).eq.0 .and. mrc(i).eq.0)
     *        t=.false.
        if (t) then
          n=n+1
          xna=xna + dfloat(nanc(i))
          do j=1, ng
            xng=xng + tab(j,i)
            moy(j)=moy(j) + tab(j,i)
            end do
          end if
       end do
      if (n.eq.0) return
      xng=xng/dfloat(n)
      xna=xna/dfloat(n)
      do i=1,ng
        moy(i)=moy(i)/dfloat(n)
        end do
      print *,'***************************************************'
      print 4001,ian, isex
      print 4004,n
      print 4005, xng,xna
      do i=1, ng
        if (moy(i).gt.0.d0) print '(i7,f12.4)',i,moy(i)
        end do

      include "format.incl"

      return
      end
