C******** verification des genealogies
      program verif_ped

      include "blk.incl"

      integer prc(nt), mrc(nt),pr(nt),mr(nt)
      integer*4   ndes(nt),liste(nt)
      integer i,j,k,l,n, nl, nbl,nbit,ip,im,ii,iopt,ic
      integer*4 iii,jjj
      logical pop(nt),poq(nt)
      logical test,t
      character*128 str,sor

      include "format.incl"

      call fdate(str)
      PRINT 990,str
      print 1600

      print 1001
      read(5,*) str
      print 1002,str

      open (1,file=str,form='FORMATTED')
      nl=0


   10 READ (1,*,END=20) i,ip,im
      NL=NL+1
      if (i.ne.nl) then
         print 102,nl,i
         stop
         end if
      if (i.gt.nt.or.ip.gt.nt.or.im.gt.nt) then
         print 101
         stop
         end if

      prc(nl)=ip
      if (ip.lt.0) prc(nl)=0
      mrc(nl)=im
      if (im.lt.0) mrc(nl)=0
      GOTO 10

   20 print 900,nl           	      


c  verification de pedigree
      k=0
      do i=1, nl
        pop(i)=.false.
        ndes(i)=0
        if (prc(i).eq.0 .and. mrc(i).eq.0)  then
            pop(i)=.true.
            k=k+1
        end if
      end do

      do i=1, nl
        ip=prc(i)
        im=mrc(i)
        if (ip.gt.0) ndes(ip)=ndes(ip)+1
        if (im.gt.0) ndes(im)=ndes(im)+1
        end do

      print 1601
      nbit=0
      test=.true.
      do while(test .and. nbit.le.20)
        nbit=nbit+1
        j=0
        test=.false.
        do i=1, nl
          if (.not.pop(i)) then
            ip=prc(i)
            im=mrc(i)
            t=.true.
            if (ip.ne.0 .and..not.pop(ip)) t=.false.
            if (im.ne.0 .and..not.pop(im)) t=.false.
            if (t) then
              pop(i) = .true.
              j=j+1
            else
              test=.true.
              end if
            end if
        end do
        k=k+j
        print '(i2,i12,i12,i12)',nbit,k,j,nl-k
      end do

      if (k.eq.nl) then
        print 1602
	stop
      else
        print 1603
	end if

      print 1604
      j=0      
      do i=1,nl
          if (.not.pop(i).and.ndes(i).gt.0) then
            j=j+1
	    liste(j)=i
            if (j.lt.400) print '(3i10,i8)',i,prc(i),mrc(i),ndes(i)
            end if
        end do
      if (j.gt.0) print 1605,j


      print 1606
      do i=1,nl
         ic=0
          if (.not.pop(i).and.ndes(i).gt.0) then
           if (i.eq.prc(i).or.i.eq.mrc(i)) then
	     ic=ic+1
	     print '(3i10)',i,prc(i),mrc(i)
             end if	
	   end if
	 end do
      print 1607,ic
      	     
      print 1608
      do i=1,nl
         ic=0
          if (.not.pop(i).and.ndes(i).gt.0) then
      if (prc(i).gt.0.and.prc(prc(i)).eq.i) then 
             ic=ic+1
	     print 1609,i
             end if
      if (prc(i).gt.0.and.mrc(prc(i)).eq.i) then 
             ic=ic+1
	     print 1610,i
             end if
      if (mrc(i).gt.0.and.prc(mrc(i)).eq.i) then 
             ic=ic+1
	     print 1611,i
             end if
      if (mrc(i).gt.0.and.mrc(mrc(i)).eq.i) then 
             ic=ic+1
	     print 1612,i
             end if
            end if
        end do
       print 1613,ic
       print *	
		
      print 1614
      jjj=j
      
c  verification de pedigree
      do i=1, nl
        pr(i)=0
        mr(i)=0
        poq(i)=.true.
        end do
      
      do iii=1, jjj
      
      ip=liste(iii)
      ic=0
      do i=1, nl
        if (prc(i).eq.ip) then
	  pr(i)=prc(i)
	  prc(i)=0
	  ic=ic+1
	  end if
        if (mrc(i).eq.ip) then
	  mr(i)=mrc(i)
	  mrc(i)=0
	  ic=ic+1
	  end if
	end do

      k=0
      nbit=0
      test=.true.
	
      j=0
      do while(test .and. nbit.le.10)
        nbit=nbit+1
        test=.false.
        do i=1, nl
          if (.not.pop(i)) then
            ip=prc(i)
            im=mrc(i)
            t=.true.
            if (ip.ne.0 .and. .not.pop(ip)) t=.false.
            if (im.ne.0 .and. .not.pop(im)) t=.false.
            if (t) then
	      poq(i)= .false.
              pop(i)= .true.	      
              j=j+1
            else
              test=.true.
            end if
          end if
        end do
      end do

      k=nl-j
      print '(i5,i10,i7,i8,i10)',iii,liste(iii),ic,nbit,j
      if (.not.test) then
        print 1615
        print *
	end if
      
      do i=1, nl
        if (.not.poq(i)) then
	  poq(i)=.true.
	  pop(i)=.false.
	  end if
        if (pr(i).ne.0) then
	  prc(i)=pr(i)
	  pr(i)=0
	  end if
        if (mr(i).ne.0) then
	  mrc(i)=mr(i)
	  mr(i)=0
	  end if
	end do   
      end do	   
       
      stop
      end
