C******** Contribution d'une serie d'ancetres a une population de reference
c
      program contribution
      implicit none

      include "blk.incl"

      integer prc(nt), mrc(nt)
      integer ord(nt)
      real*8  prob(nt)
      integer*2 ann(nt), sex(nt), ngen(nt)
      logical pop(nt)

      integer i,j,k,l,n, nl, nbit,ip,im,npop,ncontr,ii
      integer numd,numf,nums
      real*8  x
      logical t
      character*128 str,stanc,sts,stref,jour

      include "format.incl"

      call fdate(jour)
      PRINT 990,jour

      numd=2005
      numf=2010
      nums=2
      print 1700
      print *

      print 1001
      read(5,*) str
      print 1002,str

      print 1701
      read(5,*) stanc
      print 1702,stanc

      print 1703
      read(5,*) stref

      if (stref.ne.'no') then
        print 1704,stref
      else 
        print 1705
        read (5,*,end=12) nums,numd,numf
        if (numd.lt.11) then
             numd=numd+2000
        else if (numd.lt.100) then
             numd=numd+1900
             end if
        if (numf.lt.11) then
             numf=numf+2000
        else if (numf.lt.100) then
             numf=numf+1900
             end if
           
   12   continue 
        if (nums.lt.0.or.nums.gt.2) nums=2
        if (numd.gt.numf) then
          numd=numf
          endif

        print 1706,nums,numd,numf
        end if


c fichier sortie
c      sts='no'
c      print 1003
c      read(5,*,end=16) sts
c      print 1004,sts
c   16 continue


c read file 1
      open (1,file=str,form='FORMATTED')
      nl=0

   10 read (1,*,end=20) i,ip,im,l,n
      NL=NL+1
      if (l.lt.11) then
             l=l+2000
      else if (l.lt.100) then
             l=l+1900
             end if
      if (i.ne.nl) then
          print 102,nl,i
          stop
          end if
      if (i.gt.nt.or.ip.gt.nt.or.im.gt.nt) then
          print 101
          stop
          end if

      prc(nl)=ip
      if (ip.lt.0) prc(nl)=0
      mrc(nl)=im
      if (im.lt.0) mrc(nl)=0
      ann(nl)=l
      sex(nl)=n
      GOTO 10

   20 print 900, nl
      close(1)
      

c initialisations
      do i=1, nl
         prob(i)=0.d0
         pop(i)=.false.
         end do


c construction de ngen et de ord
      k=0
      do i=1, nl
        ngen(i)=-1
        if (prc(i).eq.0 .and. mrc(i).eq.0)  then
            ngen(i)=0
            k=k+1
            ord(k)=i
        end if
      end do
      nbit=0
c we assume that the complete pedigree is ordered in less than 50 loops !
      do while(k.lt.nl .and. nbit.le.50)
        nbit=nbit+1
        j=0
        do i=1, nl
          if (ngen(i).lt.0) then
            ip=prc(i)
            im=mrc(i)
            t=.true.
            if (ip.ne.0 .and. ngen(ip).lt.0) t=.false.
            if (im.ne.0 .and. ngen(im).lt.0) t=.false.
            if (t) then
              if (ip.eq.0) then
                ii=0
              else
                ii=ngen(ip)
              end if
              if (im.ne.0) ii=max(ii,ngen(im))
              ngen(i) = ii+1
              k=k+1
              ord(k)=i
              j=j+1
            end if
          end if
        end do
c        print 1000,nbit,k,j,nl-k
      end do

c Check for pedigree
      j=0
      if (k.lt.nl) then
        print 1104, nl-k
        do i=1,nl
          if (ngen(i).lt.0) then
            j=j+1
            if (j.lt.100) print '(3i10)',i,prc(i),mrc(i)
            prc(i)=0
            mrc(i)=0
            ngen(i)=0
            k=k+1
            ord(k)=i
            end if
        end do
       end if


c define ref population
      npop=0
      if (stref.eq.'no') then ! sur la base du sexe et annai
        do i=1, nl
         if (ann(i).ge.numd .and. ann(i).le.numf .and. sex(i).eq.nums
     *       .and. prc(i).ne.0  .and.  mrc(i).ne.0) then
           pop(i)=.true.
           npop=npop+1
           end if
          end do


       else  ! fichier de la pop de reference
        open(1,file=stref,form='formatted')
   11 read (1,*,end=21) i
      if (i.gt.nl) then
          print 8512,i
          stop
          end if
       npop=npop+1
       pop(i)=.true.
       GOTO 11
   21   close(1)
       end if

      print 7005,npop
      


c lecture des contributeurs
      ncontr=0
      open(1,file=stanc,form='formatted')
   13 read (1,*,end=23) i
      if (i.gt.nl) then
          print 8512,i
          stop
          end if
       ncontr=ncontr+1
       prob(i)=1.
       GOTO 13
   23   close(1)

      print 1707,ncontr      


c calcul des probas d'origine des genes avec les fondateurs initiaux
      do k=1, nl
        i=ord(k)
        if (prob(i).ne.1.) then
          ip=prc(i)
          im=mrc(i)
          if (ip.ne.0) prob(i)=prob(i) + prob(ip)*.5d0
          if (im.ne.0) prob(i)=prob(i) + prob(im)*.5d0
          end if
        end do

c statistiques
      x=0.
      do i=1,nl
        if (pop(i)) x=x+prob(i)
        end do
      x=100.*x/dfloat(npop)
      print 1708,ncontr,x

      stop
      END
