      program parente
      implicit none

      include "blk.incl"

      integer*4 i, j, k, n,ii,jj,kk,is,il,ne,eff,na,ie,ef1,ef2
      integer*4 je,nd
      character*128 str, jour,sti
      integer*4 vec(nam),pe(2,nam)
      integer*4 sire(nt),dam(nt),ped(2,nt), point(nt),po(nt)
      integer*4 ord(nt),id(nt),rord(nt),lig(nt)
      real*8 a(0:nam,0:nam)
      integer*2 rep(nt),chx(nam)

      include "format.incl"

      call fdate(jour)
      PRINT 990,jour

      print 8001
      print 1001
      read(5,*) str
      print 1002,str
      print 8002
      read(5,*) sti
      print 8003,sti

      do i=1,nam
        a(0,i)=0.d0
        a(i,0)=0.d0
      end do
      a(0,0)=0.d0

      n=0
      open (1,file=str,form='FORMATTED')
    1 read (1,*,end=2) i,j,k
      n=n+1
      if (i.ne.n) then
          print 102,n,i
          stop
          end if
      if (i.gt.nt.or.j.gt.nt.or.k.gt.nt) then
          print 101
          stop
          end if
      sire(n)=j
      if (i.eq.j) sire(n)=0
      if (j.lt.0) sire(n)=0
      dam(n)=k
      if (i.eq.k) dam(n)=0
      if (k.lt.0) dam(n)=0
      goto 1
    2 print 900,n
      close(1)

      open (1,file=sti,form='formatted')
    3 read (1,*,end=4) i,ii
      if (ii.lt.1.or.ii.gt.2) then
        print 8004,i,ii
        stop
        end if
      rep(i)=ii
      goto 3
    4 close (1)

c *** renumerotation du plus vieux au plus jeune
      call comp_d
     *   (n, sire, dam, ped, ord,rord)

      eff=0
      ef1=0
      ef2=0
      do i=1, n
        if (rep(i).gt.0) then
          eff=eff+1
          id(eff)=ord(i)
          if (rep(i).eq.1) ef1=ef1 + 1
          if (rep(i).eq.2) ef2=ef2 + 1
          end if
        end do
      if (ef2.eq.0) then
        print 8005, eff
      else
        print 8006,ef1
        print 8007,ef2
        end if

      if (eff.gt.nam) then
        print 8008,eff,nam
        stop
        end if
      do i=1,n
        point(i)=0
        end do
      call liste(eff,id, na, n,nam,
     *             ped, point, po, vec, pe,rep,lig,chx,rord)
      call relat(na,nam,vec,po,pe,a)
      call statt(na,nam,a,chx)
      print *
c      print *,'Matrice de parente'
      call impmat(a,nam,lig,eff,id,rord,rep)
      call fdate(jour)
      print *
      PRINT 991,jour
	stop
	end

      subroutine statt(na,nam,a,chx)
      implicit none
      integer*4 na,nam, numero1(2000),numero2(2000),i,ii,j,jj,k,l
      integer*2 chx(nam)
      real*8  a(0:nam,0:nam), statis(100)
      real*8    m1,m2,m12,s1,s2,s12,x
      integer*4 ef1,ef2,eff1,eff2,eff12
      character*1 etoile

      include "format.incl"

      print *
      print *
      print 8009
      etoile='*'
      ef1=0
      ef2=0
      do i=1, na
        if (chx(i).eq.1) then
          ef1=ef1+1
          numero1(ef1)=i
        else if (chx(i).eq.2) then
          ef2=ef2+1
          numero2(ef2)=i
          end if
        end do
      eff1 = ef1*(ef1-1)/2
      eff2 = ef2*(ef2-1)/2
      eff12 = ef1*ef2

      if (ef1.gt.0) then
        do i=1, 100
          statis(i)=0.d0
          end do
        m1=0.
        s1=0.
        do ii=1, ef1
          i=numero1(ii)
          do jj=1, ii-1
            j=numero1(jj)
            x=a(i,j)*.5d0
            m1=m1 + x
            s1=s1 + x*x
            k=1+int(100.d0 * x)
            statis(k)=statis(k)+1.d0
            end do
          end do

        print *
        print 8010
        m1=m1/dfloat(eff1)
        s1=s1 - eff1*m1*m1
        s1=dsqrt(s1/dfloat(eff1))
        print 8013,ef1,eff1,m1,s1
        do i=1, 100
          k=int(.5 + 100.*statis(i)/dfloat(eff1))
          if (k.gt.0) print 8014,i-1,i,k,(etoile,l=1,k)
          end do
        end if

      if (ef2.gt.0) then
        do i=1, 100
          statis(i)=0.d0
          end do
        m2=0.
        s2=0.
        do ii=1, ef2
          i=numero2(ii)
          do jj=1, ii-1
            j=numero2(jj)
            x=a(i,j)*.5d0
            m2=m2 + x
            s2=s2 + x*x
            k=1+int(100.d0 * x)
            statis(k)=statis(k)+1.d0
            end do
          end do

        print *
        print 8011
        m2=m2/dfloat(eff2)
        s2=s2 - eff2*m2*m2
        s2=dsqrt(s2/dfloat(eff2))
        print 8013,ef2,eff2,m2,s2
        do i=1, 100
          k=int(.5 + 100.*statis(i)/dfloat(eff2))
          if (k.gt.0) print 8014,i-1,i,k,(etoile,l=1,k)
          end do
        end if

      if (ef1.gt.0.and.ef2.gt.0) then
        do i=1, 100
          statis(i)=0.d0
          end do
        m12=0.
        s12=0.
        do ii=1, ef1
          i=numero1(ii)
          do jj=1, ef2
            j=numero2(jj)
            x=a(i,j)*.5d0
            m12=m12 + x
            s12=s12 + x*x
            k=1+int(100.d0 * x)
            statis(k)=statis(k)+1.d0
            end do
          end do

        print *
        print 8012
        m12=m12/dfloat(eff12)
        s12=s12 - eff12*m12*m12
        s12=dsqrt(s12/dfloat(eff12))
        print 8013,ef1+ef2,eff12,m12,s12
        do i=1, 100
          k=int(.5 + 100.*statis(i)/dfloat(eff12))
          if (k.gt.0) print 8014,i-1,i,k,(etoile,l=1,k)
          end do
        end if

      return
      end

	subroutine comp_d (n,sire, dam,ped,ord,rord)
      implicit none
      integer*4 n,sire(*),dam(*),ped(2,*),nbit,k,i,j,ks,kd
      integer*4 ord(*), rord(*)

      include "format.incl"

	nbit=0
	do i=1, n
	  ord(i)=0
	  end do
	k=0
	do while (k.lt.n.and.nbit.lt.50)
	  nbit=nbit + 1
c	  if (nbit.gt.50) stop ' subroutine comp_d: nbit>50'
	  do i=1, n
	    if (ord(i).eq.0) then
		if (sire(i).le.0 .or. ord(sire(i)).ne.0) then
	   	 if (dam(i) .le.0 .or. ord( dam(i)).ne.0) then
		  k=k+1
		  ord(i)=k
                rord(k)=i
	         end if
	        end if
	    end if
	  end do
c        print *,'iteration',nbit,k,n-k
	end do

c Check for pedigree
      j=0
      if (k.ne.n) then
        do i=1,n
          if (ord(i).eq.0) then
            j=j+1
            if (j.lt.100) print '(3i10)',j,i,sire(i),dam(i)
            end if
          sire(i)=0
          dam(i)=0
        end do
       if (j.gt.0) print 1104, j
       end if
c      if (j.gt.0) stop

      do i=1, n
	  j=rord(i)
	  ped(1,i)=sire(j)
	  ped(2,i)=dam(j)
	  if (ped(1,i).gt.0) ped(1,i)=ord(sire(j))
	  if (ped(2,i).gt.0) ped(2,i)=ord(dam(j))
        end do

      DO i=1,n
        if (i.le.ped(1,i) .or. i.le.ped(2,i)) then
          print 8015
          print '(3i10)',i, ped(1,i),ped(2,i)
          stop
          end if
        ks=ped(1,i)
        kd=ped(2,i)
        ped(1,i)=max(ks,kd)
        ped(2,i)=min(ks,kd)
        end do
	return
	end

C*** Construction de la liste des ancetres
  	subroutine liste(eff,id, np, n,nam,
     *             ped, point, po, vec, pe,rep,lig, chx, rord)
      implicit none
	integer*4 ped(2,*),point(*),po(*)
      integer*4 i,j,k,ks,kd,n,np,nam,ii,adp,eff
      integer*4 vec(nam),pe(2,nam),id(*),lig(*),rord(*)
      integer*2 rep(*),chx(nam)
      np=0
      DO ii=1,eff
        i=id(ii)
        if (ii.eq.1) then
          adp=i
          np=np+1
        if (np.gt.nam) stop 'augmenter nam'
        else
          k=adp
          if (i.gt.k) then
            adp=i
            point(i)=k
            np=np+1
        if (np.gt.nam) stop 'augmenter nam'
          else
            do while (point(k).gt.i)
              k=point(k)
              end do
            if (point(k).ne.i) then
              point(i)=point(k)
              point(k)=i
              np=np+1
        if (np.gt.nam) stop 'augmenter nam'
              end if
            end if
          end if
        j=i
        do while(j.ne.0)
          k=j
          ks=ped(1,k)
          kd=ped(2,k)

          if (ks.gt.0) then
            do while(point(k).gt.ks)
              k=point(k)
              end do
            if (ks.ne.point(k)) then
              point(ks)=point(k)
              point(k)=ks
              np=np+1
        if (np.gt.nam) stop 'augmenter nam'
              end if
            if (kd.gt.0) then
              do while(point(k).gt.kd)
                k=point(k)
                end do
              if (kd.ne.point(k)) then
                point(kd)=point(k)
                point(k)=kd
                np=np+1
        if (np.gt.nam) stop 'augmenter nam'
                end if
              end if
            end if
          j=point(j)
          end do
        end do

        if (np.gt.nam) stop 'augmenter nam'

        k=adp
        do i=1, np
          lig(i)=0
          chx(i)=0
          j=np+1-i
          vec(j)=k
          pe(1,j)=ped(1,k)
          pe(2,j)=ped(2,k)
          po(k)=j
          j=k
          j=point(j)
          point(k)=0
          k=j
          end do
        b1:do i=1, eff
          do j=np,1,-1
            if (vec(j).eq.id(i)) then
              chx(j)=rep(rord(id(i)))
              lig(id(i))=j
              cycle b1
              end if
            end do
          end do   b1
        return
        end

c construction  de A
      subroutine relat(np,nam,vec,po,pe,a)
      implicit none
      include "format.incl"
      integer*4 i,j,k,jv,pv,mv,jp,jm,np,nam
      integer*4 vec(nam),pe(2,nam),po(*)
      real*8    a(0:nam,0:nam)
      print 6009,np
      do j=1, np
        jp=pe(1,j)
        jm=pe(2,j)
        if (jp.gt.0) then
          pv=po(jp)
        else
          pv=0
          end if
        if (jm.gt.0) then
          mv=po(jm)
        else
          mv=0
          end if
        jv=j-1
        do k=1,jv
          a(j,k)= .5d0 * (a(pv,k) + a(mv,k))
          a(k,j)=a(j,k)
          end do
        a(j,j)=1.d0 + .5d0*a(pv,mv)
        end do

       RETURN
       END

       subroutine impmat(a,n,lig,eff,id,rord,rep)
       implicit none
       integer*4 n,eff,i,ii,il,j,jj,jl,nc,ef1,ef2
       real*8    a(0:n,0:n)
       integer*4 lig(*),id(*),rord(*)
       integer*2 rep(*)

       include "format.incl"

c impression complete
       print *
       print *
       print 8017
       if (eff.lt.20) then
         print *
         print 8018

         print 1,(rord(id(j)),j=1,eff)
         do i=1, eff
           ii=rord(id(i))
           il=lig(id(i))
           print 3,ii,(0.5d0*a(il,lig(id(j))),j=1,i)
           end do
         end if

       print *
       print 8117
       print *
       print 8019
       nc=0
       ef1=0
       ef2=0
       do i=1, eff
         ii=rord(id(i))
         if (rep(ii).eq.1) then
           ef1=ef1 + 1
           il=lig(id(i))
           if (a(il,il).gt.1.000001d0) then
             print 2,rep(ii),ii,a(il,il)-1.d0
             nc=nc+1
             end if
         else
           ef2=ef2+1
           end if
         end do
       if (nc.eq.0) print 8020

       print *
       if (ef2.gt.0) then
         nc=0
         do i=1, eff
           ii=rord(id(i))
           if (rep(ii).eq.2) then
             il=lig(id(i))
             if (a(il,il).gt.1.000001d0) then
               print 2,rep(ii),ii,a(il,il)-1.d0
               nc=nc+1
               end if
             end if
           end do
         if (nc.eq.0) print 8021
         end if

       print 8022

       if (ef1.gt.0) then
         print 8023
         nc=0
         do i=1, eff
           ii=rord(id(i))
           il=lig(id(i))
           do j=i+1, eff
             jj=rord(id(j))
             jl=lig(id(j))
           if (rep(ii).eq.1.and.rep(jj).eq.1.and.a(il,jl).ne.0.d0) then
               print 2,ii,jj,0.5d0*a(il,jl)
               nc=nc+1
               end if
             end do
           end do
         if (nc.eq.0) print 8025
         end if

       if (ef2.gt.0) then
         print 8024
         nc=0
         do i=1, eff
           ii=rord(id(i))
           il=lig(id(i))
           do j=i+1, eff
             jj=rord(id(j))
             jl=lig(id(j))
           if (rep(ii).eq.2.and.rep(jj).eq.2.and.a(il,jl).ne.0.d0) then
               print 2,ii,jj,0.5d0*a(il,jl)
               nc=nc+1
               end if
             end do
           end do
         if (nc.eq.0) print 8026
         end if

       if (ef1.gt.0 .and. ef2.gt.0) then
         print 8027
         nc=0
         do i=1, eff
           ii=rord(id(i))
           il=lig(id(i))
           do j=1, eff
             jj=rord(id(j))
             jl=lig(id(j))
           if (rep(ii).eq.1.and.rep(jj).eq.2.and.a(il,jl).ne.0.d0) then
               print 2,ii,jj,0.5d0*a(il,jl)
               nc=nc+1
               end if
             end do
           end do
         if (nc.eq.0) print 8028
         end if
    1 format (8x,20i6)
    2 format (2i8,f6.3)
    3 format (i8,20f6.3)
      return
      end
